#ifndef SERIAL
#include <mpi.h>
#endif

#ifndef SERIAL
 void vsmSetMpiComm(MPI_Comm com);
#endif

#ifdef USE_GFORT
 void __vismo_MOD_vismo__init4c(int *, int *, char * );
#ifdef FLOATDATA
 void __vismo_MOD_vismo__addscalars(float *, int*, int*, int *);
 void __vismo_MOD_vismo__addscalarv(float *, int*);
 void __vismo_MOD_vismo__addvectors(float *, float *, float *, int*, int*, int *);
 void __vismo_MOD_vismo__addvectorv(float *, float *, float *, int*);
 void __vismo_MOD_vismo__addptcl(float *, float *, float *, int*, int*);
 void __vismo_MOD_vismo__addptclcol(float *, float *, float *, int*, float*, int*);
#else
 void __vismo_MOD_vismo__addscalars(double *, int*, int*, int *);
 void __vismo_MOD_vismo__addscalarv(double *, int*);
 void __vismo_MOD_vismo__addvectors(double *, double *, double *, int*, int*, int *);
 void __vismo_MOD_vismo__addvectorv(double *, double *, double *, int*);
 void __vismo_MOD_vismo__addptcl(double *, double *, double *, int*, int*);
 void __vismo_MOD_vismo__addptclcol(double *, double *, double *, int*, double*, int*);
#endif
 void __vismo_MOD_vismo__initcoords4c(int *);
 void __vismo_MOD_vismo__setunicoord(int*, double*, double*);
 void __vismo_MOD_vismo__setlocalunicoord(int*, int *, int*, double*, double*);
 void __vismo_MOD_vismo__setrectcoord(int*, double*, double*, double*);
 void __vismo_MOD_vismo__setlocalrectcoord(int*, int*,int*,double*, double*, double*);
 void __vismo_MOD_vismo__preparevis();
 void __vismo_MOD_vismo__visualization4c(int *);
 void __vismo_MOD_vismo__visualization4cv(int *, int*);
 void __vismo_MOD_vismo__finalize();

#ifndef SERIAL
void vismo__init(MPI_Comm comm, int rank, int psize, char *file){
vsmSetMpiComm(comm);
__vismo_MOD_vismo__init4c(&rank, &psize, file);
}
#else
void vismo__init(char *file){
  int rank, psize;
  rank=0; psize=1;
  __vismo_MOD_vismo__init4c(&rank, &psize, file);
}
#endif

#ifdef FLOATDATA
void  vismo__addscalars(float *s, int xs, int ys, int zs){
__vismo_MOD_vismo__addscalars(s, &xs, &ys, &zs);
}

void  vismo__addscalarv(float *s, int *xs){
__vismo_MOD_vismo__addscalarv(s,xs);
}

void  vismo__addvectors(float *vx, float *vy, float *vz, int xs, int ys, int zs){
__vismo_MOD_vismo__addvectors(vx, vy, vz, &xs, &ys, &zs);
}

void  vismo__addvectorv(float *vx, float *vy, float *vz, int *xs){
__vismo_MOD_vismo__addvectorv(vx, vy, vz, xs);
}

void  vismo__addptcl(float *px, float *py, float *pz, int *ptq, int pn){
__vismo_MOD_vismo__addptcl(px, py, pz, ptq, &pn);
}

void  vismo__addptclcol(float *px, float *py, float *pz, int *ptq, float *pts, int pn){
__vismo_MOD_vismo__addptclcol(px, py, pz, ptq, pts, &pn);
}

#else
void  vismo__addscalars(double *s, int xs, int ys, int zs){
__vismo_MOD_vismo__addscalars(s, &xs, &ys, &zs);
}

void  vismo__addscalarv(double *s, int *xs){
__vismo_MOD_vismo__addscalarv(s,xs);
}

void  vismo__addvectors(double *vx, double *vy, double *vz, int xs, int ys, int zs){
__vismo_MOD_vismo__addvectors(vx, vy, vz, &xs, &ys, &zs);
}

void  vismo__addvectorv(double *vx, double *vy, double *vz, int *xs){
__vismo_MOD_vismo__addvectorv(vx, vy, vz, xs);
}

void  vismo__addptcl(double *px, double *py, double *pz, int *ptq, int pn){
__vismo_MOD_vismo__addptcl(px, py, pz, ptq, &pn);
}

void  vismo__addptclcol(double *px, double *py, double *pz, int *ptq, double *pts, int pn){
__vismo_MOD_vismo__addptclcol(px, py, pz, ptq, pts, &pn);
}

#endif
void vismo__initcoords(int uni){
  __vismo_MOD_vismo__initcoords4c(&uni);
}

void vismo__setunicoord(int *n, double *corner, double *dx){
   __vismo_MOD_vismo__setunicoord(n, corner, dx);
}

void vismo__setlocalunicoord(int *n, int *lx, int*ln, double *corner, double *dx){
   __vismo_MOD_vismo__setlocalunicoord(n, lx, ln, corner, dx);
}

void vismo__setrectcoord(int *n, double *coordx, double *coordy, double *coordz){
  __vismo_MOD_vismo__setrectcoord(n, coordx, coordy, coordz);
}

void vismo__setlocalrectcoord(int *n, int *lx, int*ln, double *coordx, double *coordy, double *coordz){
  __vismo_MOD_vismo__setlocalrectcoord(n, lx, ln, coordx, coordy, coordz);
}

void vismo__preparevis(){
  __vismo_MOD_vismo__preparevis();
}

void vismo__visualization(int step){
  __vismo_MOD_vismo__visualization4c(&step);
}

void vismo__visualizationv(int step, int *vex){
  __vismo_MOD_vismo__visualization4cv(&step, vex);
}

void vismo__finalize(){
  __vismo_MOD_vismo__finalize();
}

#endif

#ifdef USE_IFORT
 void vismo_mp_vismo__init4c_(int*, int*, char * );
#ifdef FLOADDATA
 void vismo_mp_vismo__addscalars_(float *, int*, int*, int *);
 void vismo_mp_vismo__addscalarv_(float *, int*);
 void vismo_mp_vismo__addvectors_(float *, float *, float *, int*, int*, int *);
 void vismo_mp_vismo__addvectorv_(float *, float *, float *, int*);
 void vismo_mp_vismo__addptcl_(float *, float *, float *, int*, int*);
 void vismo_mp_vismo__addptclcol_(float *, float *, float *, int*, float*, int*);
#else
 void vismo_mp_vismo__addscalars_(double *, int*, int*, int *);
 void vismo_mp_vismo__addscalarv_(double *, int*);
 void vismo_mp_vismo__addvectors_(double *, double *, double *, int*, int*, int *);
 void vismo_mp_vismo__addvectorv_(double *, double *, double *, int*);
 void vismo_mp_vismo__addptcl_(double *, double *, double *, int*, int*);
 void vismo_mp_vismo__addptclcol_(double *, double *, double *, int*, double*, int*);
#endif
 void vismo_mp_vismo__initcoords4c_(int *);
 void vismo_mp_vismo__setunicoord_(int*, double*, double*);
 void vismo_mp_vismo__setlocalunicoord_(int*, int *, int*, double*, double*);
 void vismo_mp_vismo__setrectcoord_(int*, double*, double*, double*);
 void vismo_mp_vismo__setlocalrectcoord_(int*, int*,int*,double*, double*, double*);
 void vismo_mp_vismo__preparevis_();
 void vismo_mp_vismo__visualization4c_(int *);
 void vismo_mp_vismo__visualization4cv_(int *, int *);
 void vismo_mp_vismo__finalize_();

#ifndef SERIAL
void vismo__init(MPI_Comm, int rank, int psize, char *file){
vsmSetMpiComm(comm);
vismo_mp_vismo__init4c_(&rank, &psize, file);
}
#else
void vismo__init(char *file){
 int rank, psize;
 rank=0; psize=1;
vismo_mp_vismo__init4c_(&rank, &psize, file);
}
#endif

#ifdef FLOATDATA
void  vismo__addscalars(float *s, int xs, int ys, int zs){
vismo_mp_vismo__addscalars_(s,&xs,&ys,&zs);
}

void  vismo__addscalarv(float *s, int *xs){
vismo_mp_vismo__addscalarv_(s,xs);
}

void  vismo__addvectors(float *vx, float *vy, float *vz, int xs, int ys, int zs){
vismo_mp_vismo__addvectors_(vx, vy, vz, &xs, &ys, &zs);
}

void  vismo__addvectorv(float *vx, float *vy, float *vz, int *xs){
vismo_mp_vismo__addvectorv_(vx, vy, vz, xs);
}

void  vismo__addptcl(float *px, float *py, float *pz, int *ptq, int pn){
vismo_mp_vismo__addptcl_(px, py, pz, ptq, &pn);
}

void  vismo__addptclcol(float *px, float *py, float *pz, int *ptq, float *pts, int pn){
vismo_mp_vismo__addptclcol_(px, py, pz, ptq, pts, &pn);
}

#else
void  vismo__addscalars(double *s, int xs, int ys, int zs){
vismo_mp_vismo__addscalars_(s,&xs,&ys,&zs);
}

void  vismo__addscalarv(double *s, int *xs){
vismo_mp_vismo__addscalarv_(s,xs);
}

void  vismo__addvectors(double *vx, double *vy, double *vz, int xs, int ys, int zs){
vismo_mp_vismo__addvectors_(vx, vy, vz, &xs, &ys, &zs);
}

void  vismo__addvectorv(double *vx, double *vy, double *vz, int *xs){
vismo_mp_vismo__addvectorv_(vx, vy, vz, xs);
}

void  vismo__addptcl(double *px, double *py, double *pz, int *ptq, int pn){
vismo_mp_vismo__addptcl_(px, py, pz, ptq, &pn);
}

void  vismo__addptclcol(double *px, double *py, double *pz, int *ptq, double *pts, int pn){
vismo_mp_vismo__addptclcol_(px, py, pz, ptq, pts, &pn);
}

#endif
void vismo__initcoords(int uni){
  vismo_mp_vismo__initcoords4c_(&uni);
}

void vismo__setunicoord(int *n, double *corner, double *dx){
   vismo_mp_vismo__setunicoord_(n, corner, dx);
}

void vismo__setlocalunicoord(int *n, int *lx, int*ln, double *corner, double *dx){
   vismo_mp_vismo__setlocalunicoord_(n, lx, ln, corner, dx);
}

void vismo__setrectcoord(int *n, double *coordx, double *coordy, double *coordz){
  vismo_mp_vismo__setrectcoord_(n, coordx, coordy, coordz);
}

void vismo__setlocalrectcoord(int *n, int *lx, int*ln, double *coordx, double *coordy, double *coordz){
  vismo_mp_vismo__setlocalrectcoord_(n, lx, ln, coordx, coordy, coordz);
}

void vismo__preparevis(){
  vismo_mp_vismo__preparevis_();
}

void vismo__visualization(int step){
  vismo_mp_vismo__visualization4c_(&step);
}

void vismo__visualizationv(int step, int *vex){
  vismo_mp_vismo__visualization4cv_(&step, vex);
}

void vismo__finalize(){
  vismo_mp_vismo__finalize_();
}


#endif
