#ifndef __VISMO4C_H__
#define __VISMO4C_H__

#ifndef SERIAL
#include <mpi.h>
#endif

/*For gfortran+gcc and ifort + icc 
#define USE_GFORT
*/

#ifndef SERIAL
void vismo__init(MPI_Comm comm, int rank, int psize, char *file);
#else
void vismo__init(char *file);
#endif

#ifdef FLOATDATA
void  vismo__addscalars(float *s, int xs, int ys, int zs);
void  vismo__addscalarv(float *s, int *xs);
void  vismo__addvectors(float *vx, float *vy, float *vz, int xs, int ys, int zs);
void  vismo__addvectorv(float *vx, float *vy, float *vz, int *xs);
void  vismo__addptcl(float *px, float *py, float *pz, int *ptq, int pn);
void  vismo__addptclcol(float *px, float *py, float *pz, int *ptq, float *pts, int pn);

#else
void  vismo__addscalars(double *s, int xs, int ys, int zs);
void  vismo__addscalarv(double *s, int *xs);
void  vismo__addvectors(double *vx, double *vy, double *vz, int xs, int ys, int zs);
void  vismo__addvectorv(double *vx, double *vy, double *vz, int *xs);
void  vismo__addptcl(double *px, double *py, double *pz, int *ptq, int pn);
void  vismo__addptclcol(double *px, double *py, double *pz, int *ptq, double *pts, int pn);
#endif

void vismo__initcoords(int uni);void vismo__setunicoord(int *n, double *corner, double *dx);
void vismo__setlocalunicoord(int *n, int *lx, int*ln, double *corner, double *dx);
void vismo__setrectcoord(int *n, double *coordx, double *coordy, double *coordz);
void vismo__setlocalrectcoord(int *n, int *lx, int*ln, double *coordx, double *coordy, double *coordz);
void vismo__preparevis();
void vismo__visualization(int step);
void vismo__visualizationv(int step, int *vex);
void vismo__finalize();

const int vismo__uniform = 1;
const int vismo__rect = 0;

#endif
