module vsmParticle
 use vsmConst
 use vsmFunction
 use vsmData
 use vsmCoordinates
 use vsmParam
 use vsmSolidDrawer
 use vsmColorMap

 implicit none
 private
 
 public vsmDrawParticlesIM

 contains

 subroutine vsmDrawParticlesIM(vis_num, cam_num)
   integer, intent(in) :: vis_num, cam_num

   integer :: i, j
   integer :: nptcl, particle_num
   real, dimension(3) :: amb, dif, spec
   real :: shin
   real(kind=vdp) :: rad, val
   real, dimension(4) :: col
   real(kind=vdp), dimension(3) :: pos
   logical :: mono

   call vsmLogPrint("vsmDrawParticles")
   do j=1, vsmVisParam(vis_num)%ptcl_num
     call vsmLogPrint("particle kind:", j)
     nptcl     = vsmVisParam(vis_num)%ptclparam(j)%nptcl
     mono   = vsmVisParam(vis_num)%ptclparam(j)%monocolor

     particle_num = size(vsmPtcData(nptcl)%q)
     if(vsmDbg) then
       call vsmLogPrint("num of particles :", particle_num)
       call vsmLogPrint("amb of particles :", amb)
       call vsmLogPrint("dif of particles :", dif)
       call vsmLogPrint("spec of particles :", spec)
       call vsmLogPrint("shin of particles :", shin)
     end if
     if(mono) then
     amb(1:3)  = vsmVisParam(vis_num)%ptclparam(j)%amb(1:3)
     dif(1:3)  = vsmVisParam(vis_num)%ptclparam(j)%dif(1:3)
     spec(1:3) = vsmVisParam(vis_num)%ptclparam(j)%spec(1:3)
     shin      = vsmVisParam(vis_num)%ptclparam(j)%shin
     rad       = vsmVisParam(vis_num)%ptclparam(j)%radius
!$omp parallel do private(i,pos)
     do i=1, particle_num
       !call vsmLogPrint("particle number:", i)
       if(vsmPtcData(nptcl)%q(i) /= 0) cycle
       pos(1) = vsmPtcData(nptcl)%x(i)
       pos(2) = vsmPtcData(nptcl)%y(i)
       pos(3) = vsmPtcData(nptcl)%z(i)
        !call vsmLogPrint("particle pos:", pos)
       call vsmDrawSphere(pos, rad, cam_num, vis_num, amb, dif, spec, shin)
     end do
     else
       shin      = vsmVisParam(vis_num)%ptclparam(j)%shin
!$omp parallel do private(i,pos, val, rad, amb, dif, spec, col)
     do i=1, particle_num
       !call vsmLogPrint("particle number:", i)
       if(vsmPtcData(nptcl)%q(i) /= 0) cycle
       pos(1) = vsmPtcData(nptcl)%x(i)
       pos(2) = vsmPtcData(nptcl)%y(i)
       pos(3) = vsmPtcData(nptcl)%z(i)
       val = vsmPtcData(nptcl)%scal(i)
        !call vsmLogPrint("particle pos:", pos)
       call vsmGetPColor(val, nptcl, col)
       rad       = col(4)
       amb(1:3) = col(1:3)*vsmVisParam(vis_num)%ptclparam(j)%amb(1)
       dif(1:3) = col(1:3)*vsmVisParam(vis_num)%ptclparam(j)%dif(1)
       spec(1:3) = col(1:3)*vsmVisParam(vis_num)%ptclparam(j)%spec(1)
       call vsmDrawSphere(pos, rad, cam_num, vis_num, amb, dif, spec, shin)
     end do
     end if

   end do
 end subroutine vsmDrawParticlesIM

 end module vsmParticle

